{
  uint64_t  now;
  uint64_t first ;
  int offset,local,perm, ptype;
  const SiteHalfSpinor *pbuf = & buf[0];
  const SiteSpinor   *plocal = & in._odata[0];
  void *pf;
  int osites = in._grid->oSites();
  
  StencilEntry *SE;
  
  int stp=0;

  vComplexF signs[2];
  vrsign(signs[0]);
  visign(signs[1]);

  LOAD64(%r10,signs);  // times i => shuffle and xor the real part sign bit

#define STAMP
//define STAMP if(ss==3) { now = cyclecount() ; stamps[stp++] = now -first ; first = now; } 

  MASK_REGS;

  first = cyclecount();

  ////////////////////////////////
  // Xp
  ////////////////////////////////

  SE=st.GetEntry(ptype,Xp,ss);

  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

#undef PrefetchSpinor

#define PrefetchSpinor(X,Y)			\
  SE=st.GetEntry(ptype,Y,ss);\
  if (SE->_is_local) {pf=(void *)&plocal[SE->_offset];  }\
  else               {pf=(void *)&pbuf[SE->_offset]  ;  }

  PrefetchSpinor(Xp,Yp);

  if ( local ) {
    XM_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR3);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFXP(Xp,pf);
  }
  STAMP;
  XM_RECON;
  STAMP;

  ////////////////////////////////
  // Yp
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  PrefetchSpinor(Yp,Zp);

  if ( local ) {
    YM_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR2);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFYP(Yp,pf);
  }
  STAMP;
  YM_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Zp
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  PrefetchSpinor(Zp,Tp);

  if ( local ) {
    ZM_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR1);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFZP(Zp,pf);
  }
  STAMP;
  ZM_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Tp
  ////////////////////////////////
  perm   = SE->_permute;
  offset = SE->_offset;
  local  = SE->_is_local;
  
  PrefetchSpinor(Tp,Xm);
       
  if ( local ) {
    TM_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR0);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFTP(Tp,pf);
  }
  STAMP;
  TM_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Xm
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  PrefetchSpinor(Xm,Ym);
  
  if ( local ) {
    XP_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR3);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFXM(Xm,pf);
  }
  STAMP;
  XP_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Ym
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  PrefetchSpinor(Ym,Zm);
  
  if ( local ) {
    YP_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR2);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFYM(Ym,pf);
  }
  STAMP;
  YP_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Zm
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  PrefetchSpinor(Zm,Tm);

  if ( local ) {
    ZP_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR1);
    STAMP;
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP;
  }
  {
    MULT_2SPIN_DIR_PFZM(Zm,pf);
  }
  STAMP;
  ZP_RECON_ACCUM;
  STAMP;

  ////////////////////////////////
  // Tm
  ////////////////////////////////
  offset = SE->_offset;
  local  = SE->_is_local;
  perm   = SE->_permute;

  pf = (void *)&out._odata[ss];

  if ( local ) {
    TP_PROJMEM(&plocal[offset]);
    MAYBEPERM(PERMUTE_DIR0);
    STAMP; 
  } else { 
    LOAD_CHI(&pbuf[offset]);
    STAMP; 
  }
  {
    MULT_2SPIN_DIR_PFTM(Tm,pf);
  }
  STAMP; 
  TP_RECON_ACCUM;
  STAMP; 

 debug:
  SAVE_RESULT(&out._odata[ss]);
  STAMP; 

}
